/*
 * Copyright 2021 peter.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package hk.quantr.netbeans.verilog.window.projectoutline;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import hk.quantr.netbeans.verilog.projecttype.VerilogProject;
import hk.quantr.verilogcompiler.antlr.VerilogLexer;
import hk.quantr.verilogcompiler.antlr.VerilogParser;
import hk.quantr.verilogcompiler.structure.Module;
import hk.quantr.verilogcompiler.structure.Port;
import java.awt.Component;
import java.io.File;
import java.io.FileInputStream;
import java.util.ArrayList;
import java.util.Collection;
import javax.swing.DefaultListCellRenderer;
import javax.swing.JList;
import javax.swing.tree.DefaultTreeModel;
import org.antlr.v4.runtime.CharStreams;
import org.antlr.v4.runtime.CommonTokenStream;
import org.apache.commons.io.FileUtils;
import org.apache.commons.io.IOUtils;
import org.netbeans.api.project.Project;
import org.netbeans.api.project.ui.OpenProjects;
import org.netbeans.api.settings.ConvertAsProperties;
import org.openide.awt.ActionID;
import org.openide.awt.ActionReference;
import org.openide.util.Exceptions;
import org.openide.windows.TopComponent;
import org.openide.util.NbBundle.Messages;

/**
 * Top component which displays something.
 */
@ConvertAsProperties(
		dtd = "-//hk.quantr.netbeans.verilog.window//ProjectOutline//EN",
		autostore = false
)
@TopComponent.Description(
		preferredID = "ProjectOutlineTopComponent",
		iconBase = "hk/quantr/netbeans/verilog/verilog.png",
		persistenceType = TopComponent.PERSISTENCE_ALWAYS
)
@TopComponent.Registration(mode = "rightSlidingSide", openAtStartup = false)
@ActionID(category = "Window", id = "hk.quantr.netbeans.verilog.window.projectoutline.ProjectOutlineTopComponent")
@ActionReference(path = "Menu/Window" /*, position = 333 */)
@TopComponent.OpenActionRegistration(
		displayName = "#CTL_ProjectOutlineAction",
		preferredID = "ProjectOutlineTopComponent"
)
@Messages({
	"CTL_ProjectOutlineAction=Project Outline",
	"CTL_ProjectOutlineTopComponent=Project Outline",
	"HINT_ProjectOutlineTopComponent=This is a Project Outline window"
})
public final class ProjectOutlineTopComponent extends TopComponent {

	public ProjectOutlineTopComponent() {
		initComponents();
		setName(Bundle.CTL_ProjectOutlineTopComponent());
		setToolTipText(Bundle.HINT_ProjectOutlineTopComponent());

		projectComboBox.setRenderer(new DefaultListCellRenderer() {

			@Override
			public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
				String text = null;
				if (value != null) {
					text = ((Project) value).getProjectDirectory().getName();
				}
				return super.getListCellRendererComponent(list, text, index, isSelected, cellHasFocus);
			}
		});

		refreshProjectButtonActionPerformed(null);
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
	 * Editor.
	 */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jPanel1 = new javax.swing.JPanel();
        projectComboBox = new javax.swing.JComboBox<>();
        refreshProjectButton = new javax.swing.JButton();
        refreshButton = new javax.swing.JButton();

        setLayout(new java.awt.BorderLayout());

        jTree1.setModel(new DefaultTreeModel(null));
        jTree1.setCellRenderer(new ProjectOutlineTreeRenderer());
        jScrollPane1.setViewportView(jTree1);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel1.add(projectComboBox);

        refreshProjectButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/hk/quantr/netbeans/verilog/icon/arrow_refresh.png"))); // NOI18N
        org.openide.awt.Mnemonics.setLocalizedText(refreshProjectButton, org.openide.util.NbBundle.getMessage(ProjectOutlineTopComponent.class, "ProjectOutlineTopComponent.refreshProjectButton.text")); // NOI18N
        refreshProjectButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                refreshProjectButtonActionPerformed(evt);
            }
        });
        jPanel1.add(refreshProjectButton);

        org.openide.awt.Mnemonics.setLocalizedText(refreshButton, org.openide.util.NbBundle.getMessage(ProjectOutlineTopComponent.class, "ProjectOutlineTopComponent.refreshButton.text")); // NOI18N
        refreshButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                refreshButtonActionPerformed(evt);
            }
        });
        jPanel1.add(refreshButton);

        add(jPanel1, java.awt.BorderLayout.PAGE_START);
    }// </editor-fold>//GEN-END:initComponents

    private void refreshButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_refreshButtonActionPerformed
		try {
			Project project = (Project) projectComboBox.getSelectedItem();
			String path = project.getProjectDirectory().getPath();
			Collection<File> files = FileUtils.listFiles(new File(path), new String[]{"v"}, true);

			ProjectTreeNode root = new ProjectTreeNode((VerilogProject) project);

			ArrayList<Module> outputs = new ArrayList<>();
			for (File file : files) {
				if (file.isFile()) {
					String content = IOUtils.toString(new FileInputStream(file), "utf-8");
					Module output = parseVerilog(content);
					outputs.add(output);
					if (output.name != null && !output.name.equals("")) {
						ModuleTreeNode moduleNode = new ModuleTreeNode(output);
						root.add(moduleNode);

						for (Port input : output.inputs) {
							moduleNode.add(new PortTreeNode(input));
						}
						for (Port o : output.outputs) {
							moduleNode.add(new PortTreeNode(o));
						}
					}
				}
			}
			Gson gson = new GsonBuilder().setPrettyPrinting().create();
			System.out.println(gson.toJson(outputs));

			jTree1.setModel(new DefaultTreeModel(root));
			jTree1.setRowHeight(0);
		} catch (Exception ex) {
			Exceptions.printStackTrace(ex);
		}
    }//GEN-LAST:event_refreshButtonActionPerformed

    private void refreshProjectButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_refreshProjectButtonActionPerformed
		projectComboBox.removeAllItems();
		for (Project project : OpenProjects.getDefault().getOpenProjects()) {
			projectComboBox.addItem(project);
		}
    }//GEN-LAST:event_refreshProjectButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTree jTree1;
    private javax.swing.JComboBox<Project> projectComboBox;
    private javax.swing.JButton refreshButton;
    private javax.swing.JButton refreshProjectButton;
    // End of variables declaration//GEN-END:variables
	@Override
	public void componentOpened() {
		// TODO add custom code on component opening
	}

	@Override
	public void componentClosed() {
		// TODO add custom code on component closing
	}

	void writeProperties(java.util.Properties p) {
		// better to version settings since initial version as advocated at
		// http://wiki.apidesign.org/wiki/PropertyFiles
		p.setProperty("version", "1.0");
		// TODO store your settings
	}

	void readProperties(java.util.Properties p) {
		String version = p.getProperty("version");
		// TODO read your settings according to their version
	}

	private static Module parseVerilog(String content) {
		VerilogLexer lexer = new VerilogLexer(CharStreams.fromString(content));
		CommonTokenStream tokenStream = new CommonTokenStream(lexer);
		ProjectOutlineVerilogListener listener = new ProjectOutlineVerilogListener();
		VerilogParser parser = new VerilogParser(tokenStream);
		parser.addParseListener(listener);
		VerilogParser.Source_textContext context = parser.source_text();

		Module output = new Module();
		output.name = listener.moduleName;
		output.inputs = listener.inputs;
		output.outputs = listener.outputs;
		return output;
	}
}
